Package groovy.xml.slurpersupport

# Class Attribute

java.lang.Object
groovy.lang.GroovyObjectSupport
groovy.xml.slurpersupport.GPathResult
groovy.xml.slurpersupport.Attribute

All Implemented Interfaces:
  `Buildable`, `GroovyObject`, `Writable`, `Iterable`

public class Attribute extends GPathResult
Lazy evaluated representation of a node attribute.

- ## Field Summary

  ### Fields inherited from class groovy.xml.slurpersupport.GPathResult

  `name, namespaceMap, namespacePrefix, namespaceTagHints, parent`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Attribute(String name, String value, GPathResult parent, String namespacePrefix, Map<String,String> namespaceTagHints)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `appendNode(Object newValue)`
  NOP, because a node can not be appended to an attribute.
  `void`
  `build(GroovyObject builder)`
  Builds this object into the supplied builder.
  `Iterator`
  `childNodes()`
  Throws a `GroovyRuntimeException`, because an attribute can have no children.
  `GPathResult`
  `find(Closure closure)`
  Returns the first child of this GPathResult matching the condition(s) specified in the passed closure.
  `GPathResult`
  `findAll(Closure closure)`
  Returns the children of this GPathResult matching the condition(s) specified in the passed closure.
  `Iterator`
  `iterator()`
  `String`
  `name()`
  Returns this attribute name without the leading `@` used in GPath selectors.
  `String`
  `namespaceURI()`
  Returns the URI of the namespace of this Attribute.
  `Iterator`
  `nodeIterator()`
  Returns the raw node iterator backing this lazy result.
  `GPathResult`
  `parents()`
  Throws a `GroovyRuntimeException`, because this method is not implemented yet.
  `protected void`
  `replaceBody(Object newValue)`
  NOP, because an attribute does not have a Body.
  `protected void`
  `replaceNode(Closure newValue)`
  NOP, because an attribute does not have any Node to replace.
  `int`
  `size()`
  Returns the size of this Attribute, which is always `1`.
  `String`
  `text()`
  Returns the value of this Attribute.
  `Writer`
  `writeTo(Writer out)`
  Writes this object to the given writer.

  ### Methods inherited from class groovy.xml.slurpersupport.GPathResult

  `breadthFirst, children, createIterator, declareNamespace, depthFirst, equals, getAt, getAt, getBody, getProperty, hashCode, isEmpty, leftShift, list, lookupNamespace, parent, plus, plus, pop, putAt, setMetaClass, setProperty, toBigDecimal, toBigInteger, toBoolean, toDouble, toFloat, toInteger, toLong, toString, toURI, toURL`

  ### Methods inherited from class groovy.lang.GroovyObjectSupport

  `getMetaClass`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface groovy.lang.GroovyObject

  `invokeMethod`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

- ## Constructor Details

  - ### Attribute

    public Attribute(String name, String value, GPathResult parent, String namespacePrefix, Map<String,String> namespaceTagHints)
    Parameters:
      `name` - of the attribute
      `value` - of the attribute
      `parent` - the GPathResult prior to the application of the expression creating this GPathResult
      `namespacePrefix` - the namespace prefix if any
      `namespaceTagHints` - the known tag to namespace mappings

- ## Method Details

  - ### name

    public String name()
    Returns this attribute name without the leading `@` used in GPath selectors.
    Overrides:
      `name` in class `GPathResult`
    Returns:
      the name of this GPathResult

  - ### size

    public int size()
    Returns the size of this Attribute, which is always `1`.
    Specified by:
      `size` in class `GPathResult`
    Returns:
      `1`

  - ### text

    public String text()
    Returns the value of this Attribute.
    Specified by:
      `text` in class `GPathResult`
    Returns:
      the value of this Attribute

  - ### namespaceURI

    public String namespaceURI()
    Returns the URI of the namespace of this Attribute.
    Returns:
      the namespace of this Attribute

  - ### parents

    public GPathResult parents()
    Throws a `GroovyRuntimeException`, because this method is not implemented yet.
    Specified by:
      `parents` in class `GPathResult`
    Returns:
      the parents of this GPathResult

  - ### childNodes

    public Iterator childNodes()
    Throws a `GroovyRuntimeException`, because an attribute can have no children.
    Specified by:
      `childNodes` in class `GPathResult`
    Returns:
      an iterator over the child nodes of this GPathResult

  - ### iterator

    public Iterator iterator()
    Specified by:
      `iterator` in interface `Iterable`
    Specified by:
      `iterator` in class `GPathResult`

  - ### find

    public GPathResult find(Closure closure)
    Returns the first child of this GPathResult matching the condition(s) specified in the passed closure.
    Specified by:
      `find` in class `GPathResult`
    Parameters:
      `closure` - a closure to filters the children of this GPathResult
    Returns:
      the first child matching the closure

  - ### findAll

    public GPathResult findAll(Closure closure)
    Returns the children of this GPathResult matching the condition(s) specified in the passed closure.
    Specified by:
      `findAll` in class `GPathResult`
    Parameters:
      `closure` - a closure to filters the children of this GPathResult
    Returns:
      the children matching the closure

  - ### nodeIterator

    public Iterator nodeIterator()
    Returns the raw node iterator backing this lazy result.
    Specified by:
      `nodeIterator` in class `GPathResult`
    Returns:
      the underlying node iterator

  - ### writeTo

    public Writer writeTo(Writer out) throws IOException
    Writes this object to the given writer.

    This is used to defer content creation until the point when it is streamed to the output destination. Oftentimes, content will be defined but not necessarily created (as it may be the case with a Closure definition.) In that case, the output is then 'deferred' to the point when it is serialized to the writer. This class may be used whenever an object should be responsible for creating its own textual representation, but creating the entire output as a single String would be inefficient (such as outputting a multi-gigabyte XML document.)

    Parameters:
      `out` - the Writer to which this Writable should output its data.
    Returns:
      the Writer that was passed
    Throws:
      `IOException` - if an error occurred while outputting data to the writer

  - ### build

    public void build(GroovyObject builder)
    Builds this object into the supplied builder.
    Parameters:
      `builder` - the target builder

  - ### replaceNode

    protected void replaceNode(Closure newValue)
    NOP, because an attribute does not have any Node to replace.
    Specified by:
      `replaceNode` in class `GPathResult`
    Parameters:
      `newValue` - closure generating the replacement content

  - ### replaceBody

    protected void replaceBody(Object newValue)
    NOP, because an attribute does not have a Body.
    Specified by:
      `replaceBody` in class `GPathResult`
    Parameters:
      `newValue` - replacement body content

  - ### appendNode

    protected void appendNode(Object newValue)
    NOP, because a node can not be appended to an attribute.
    Specified by:
      `appendNode` in class `GPathResult`
    Parameters:
      `newValue` - content to append